diff -Naur --exclude=CVS --exclude=configs linux/Makefile linux-openmosix/Makefile
--- linux/Makefile	2004-01-05 14:53:56.000000000 +0100
+++ linux-openmosix/Makefile	2004-02-05 10:50:31.000000000 +0100
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 24
-EXTRAVERSION =
+EXTRAVERSION = -om
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
@@ -128,7 +128,12 @@
 NETWORKS	=net/network.o
 
 LIBS		=$(TOPDIR)/lib/lib.a
+ifdef CONFIG_MOSIX
+CORE_FILES	+= $(TOPDIR)/hpc/hpc.o
+SUBDIRS		=hpc kernel drivers mm fs net ipc lib crypto
+else
 SUBDIRS		=kernel drivers mm fs net ipc lib crypto
+endif
 
 DRIVERS-n :=
 DRIVERS-y :=
@@ -224,6 +229,11 @@
 	net/khttpd/make_times_h \
 	net/khttpd/times.h \
 	submenu*
+
+CLEAN_FILES += arch/i386/kernel/mosasm.H arch/i386/kernel/offset \
+	hpc/auto_syscalls.c hpc/mkdefcalls hpc/alternate.c \
+	vmlinux.symtab
+
 # directories removed with 'make clean'
 CLEAN_DIRS = \
 	modules
diff -Naur --exclude=CVS --exclude=configs linux/mm/filemap.c linux-openmosix/mm/filemap.c
--- linux/mm/filemap.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/filemap.c	2004-02-05 10:51:31.000000000 +0100
@@ -30,6 +30,13 @@
 
 #include <linux/highmem.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * Shared mappings implemented 30.11.1994. It's not fully working yet,
  * though.
@@ -54,7 +61,7 @@
 
 spinlock_cacheline_t pagecache_lock_cacheline  = {SPIN_LOCK_UNLOCKED};
 /*
- * NOTE: to avoid deadlocking you must never acquire the pagemap_lru_lock 
+ * NOTE: to avoid deadlocking you must never acquire the pagemap_lru_lock
  *	with the pagecache_lock held.
  *
  * Ordering:
@@ -220,6 +227,9 @@
 
 	spin_unlock(&pagecache_lock);
 	spin_unlock(&pagemap_lru_lock);
+#ifdef CONFIG_MOSIX
+	OPENMOSIX_VMODIFIED(inode);
+#endif /* CONFIG_MOSIX */
 }
 
 static int do_flushpage(struct page *page, unsigned long offset)
@@ -249,7 +259,7 @@
 	 * destroyed all buffer-cache references to it. Otherwise some
 	 * other process might think this inode page is not in the
 	 * page cache and creates a buffer-cache alias to it causing
-	 * all sorts of fun problems ...  
+	 * all sorts of fun problems ...
 	 */
 	ClearPageDirty(page);
 	ClearPageUptodate(page);
@@ -294,7 +304,7 @@
 				if (*partial && (offset + 1) == start) {
 					truncate_partial_page(page, *partial);
 					*partial = 0;
-				} else 
+				} else
 					truncate_complete_page(page);
 
 				UnlockPage(page);
@@ -326,7 +336,7 @@
  * that are beyond that offset (and zeroing out partial pages).
  * If any page is locked we wait for it to become unlocked.
  */
-void truncate_inode_pages(struct address_space * mapping, loff_t lstart) 
+void truncate_inode_pages(struct address_space * mapping, loff_t lstart)
 {
 	unsigned long start = (lstart + PAGE_CACHE_SIZE - 1) >> PAGE_CACHE_SHIFT;
 	unsigned partial = lstart & (PAGE_CACHE_SIZE - 1);
@@ -550,7 +560,7 @@
 /**
  *      filemap_fdatasync - walk the list of dirty pages of the given address space
  *     	and writepage() all of them.
- * 
+ *
  *      @mapping: address space structure to write
  *
  */
@@ -594,7 +604,7 @@
 /**
  *      filemap_fdatawait - walk the list of locked pages of the given address space
  *     	and wait for all of them.
- * 
+ *
  *      @mapping: address space structure to wait for
  *
  */
@@ -630,7 +640,7 @@
 /*
  * Add a page to the inode page cache.
  *
- * The caller must have locked the page and 
+ * The caller must have locked the page and
  * set all the page flags correctly..
  */
 void add_to_page_cache_locked(struct page * page, struct address_space *mapping, unsigned long index)
@@ -714,7 +724,7 @@
 {
 	struct address_space *mapping = file->f_dentry->d_inode->i_mapping;
 	struct page **hash = page_hash(mapping, offset);
-	struct page *page; 
+	struct page *page;
 
 	spin_lock(&pagecache_lock);
 	page = __find_page_nolock(mapping, offset, *hash);
@@ -732,7 +742,7 @@
 		return error;
 	}
 	/*
-	 * We arrive here in the unlikely event that someone 
+	 * We arrive here in the unlikely event that someone
 	 * raced with us and added our page to the cache first.
 	 */
 	page_cache_release(page);
@@ -829,13 +839,14 @@
 void wakeup_page_waiters(struct page * page)
 {
 	wait_queue_head_t * head;
-
+	
 	head = page_waitqueue(page);
 	if (waitqueue_active(head))
 		wake_up(head);
 }
 
-/* 
+
+/*
  * Wait for a page to get unlocked.
  *
  * This must be called with the caller "holding" the page,
@@ -1048,11 +1059,11 @@
 			spin_unlock(&pagecache_lock);
 			if (newpage == NULL)
 				lru_cache_add(page);
-			else 
+			else
 				page_cache_release(newpage);
 		}
 	}
-	return page;	
+	return page;
 }
 
 /*
@@ -1108,11 +1119,11 @@
 /*
  * Read-ahead profiling information
  * --------------------------------
- * Every PROFILE_MAXREADCOUNT, the following information is written 
+ * Every PROFILE_MAXREADCOUNT, the following information is written
  * to the syslog:
  *   Percentage of asynchronous read-ahead.
  *   Average of read-ahead fields context value.
- * If DEBUG_READAHEAD is defined, a snapshot of these fields is written 
+ * If DEBUG_READAHEAD is defined, a snapshot of these fields is written
  * to the syslog.
  */
 
@@ -1188,7 +1199,7 @@
  *
  * Synchronous read-ahead benefits:
  * --------------------------------
- * Using reasonable IO xfer length from peripheral devices increase system 
+ * Using reasonable IO xfer length from peripheral devices increase system
  * performances.
  * Reasonable means, in this context, not too large but not too small.
  * The actual maximum value is:
@@ -1197,22 +1208,22 @@
  *
  * Asynchronous read-ahead benefits:
  * ---------------------------------
- * Overlapping next read request and user process execution increase system 
+ * Overlapping next read request and user process execution increase system
  * performance.
  *
  * Read-ahead risks:
  * -----------------
  * We have to guess which further data are needed by the user process.
- * If these data are often not really needed, it's bad for system 
+ * If these data are often not really needed, it's bad for system
  * performances.
- * However, we know that files are often accessed sequentially by 
- * application programs and it seems that it is possible to have some good 
+ * However, we know that files are often accessed sequentially by
+ * application programs and it seems that it is possible to have some good
  * strategy in that guessing.
  * We only try to read-ahead files that seems to be read sequentially.
  *
  * Asynchronous read-ahead risks:
  * ------------------------------
- * In order to maximize overlapping, we must start some asynchronous read 
+ * In order to maximize overlapping, we must start some asynchronous read
  * request from the device, as soon as possible.
  * We must be very careful about:
  * - The number of effective pending IO read requests.
@@ -1250,7 +1261,7 @@
  * If the current position is inside the previous read IO request, do not
  * try to reread previously read ahead pages.
  * Otherwise decide or not to read ahead some pages synchronously.
- * If we are not going to read ahead, set the read ahead context for this 
+ * If we are not going to read ahead, set the read ahead context for this
  * page only.
  */
 	if (PageLocked(page)) {
@@ -1279,7 +1290,7 @@
 /*
  * Add ONE page to max_ahead in order to try to have about the same IO max size
  * as synchronous read-ahead (MAX_READAHEAD + 1)*PAGE_CACHE_SIZE.
- * Compute the position of the last page we have tried to read in order to 
+ * Compute the position of the last page we have tried to read in order to
  * begin to read ahead just at the next page.
  */
 		raend -= 1;
@@ -1372,7 +1383,7 @@
 	offset = *ppos & ~PAGE_CACHE_MASK;
 
 /*
- * If the current position is outside the previous read-ahead window, 
+ * If the current position is outside the previous read-ahead window,
  * we reset the current read-ahead context and set read ahead max to zero
  * (will be set to just needed value later),
  * otherwise, we assume that the file accesses are sequential enough to
@@ -1415,7 +1426,7 @@
 		unsigned long end_index, nr, ret;
 
 		end_index = inode->i_size >> PAGE_CACHE_SHIFT;
-			
+
 		if (index > end_index)
 			break;
 		nr = PAGE_CACHE_SIZE;
@@ -1555,7 +1566,7 @@
 		page = cached_page;
 		__add_to_page_cache(page, mapping, index, hash);
 		spin_unlock(&pagecache_lock);
-		lru_cache_add(page);		
+		lru_cache_add(page);
 		cached_page = NULL;
 
 		goto readpage;
@@ -1651,7 +1662,7 @@
 
 		if (rw == READ && retval > 0)
 			mark_dirty_kiobuf(iobuf, retval);
-		
+
 		if (retval >= 0) {
 			count -= retval;
 			buf += retval;
@@ -1673,7 +1684,7 @@
 		clear_bit(0, &filp->f_iobuf_lock);
 	else
 		free_kiovec(1, &iobuf);
- out:	
+ out:
 	return retval;
 }
 
@@ -1688,7 +1699,7 @@
 	kaddr = kmap(page);
 	left = __copy_to_user(desc->buf, kaddr + offset, size);
 	kunmap(page);
-	
+
 	if (left) {
 		size -= left;
 		desc->error = -EFAULT;
@@ -1798,6 +1809,10 @@
 	struct file * in_file, * out_file;
 	struct inode * in_inode, * out_inode;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_touch_file(in_fd);
+	dfsa_touch_file(out_fd);
+#endif /* CONFIG_MOSIX_DFSA */
 	/*
 	 * Get input file, and verify that it is ok..
 	 */
@@ -2060,7 +2075,7 @@
 
 no_cached_page:
 	/*
-	 * If the requested offset is within our file, try to read a whole 
+	 * If the requested offset is within our file, try to read a whole
 	 * cluster of pages at once.
 	 *
 	 * Otherwise, we're off the end of a privately mapped file,
@@ -2164,7 +2179,7 @@
 }
 
 static inline int filemap_sync_pte_range(pmd_t * pmd,
-	unsigned long address, unsigned long size, 
+	unsigned long address, unsigned long size,
 	struct vm_area_struct *vma, unsigned long offset, unsigned int flags)
 {
 	pte_t * pte;
@@ -2194,7 +2209,7 @@
 }
 
 static inline int filemap_sync_pmd_range(pgd_t * pgd,
-	unsigned long address, unsigned long size, 
+	unsigned long address, unsigned long size,
 	struct vm_area_struct *vma, unsigned int flags)
 {
 	pmd_t * pmd;
@@ -2327,6 +2342,10 @@
 	struct vm_area_struct * vma;
 	int unmapped_error, error = -EINVAL;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DDEPUTY)
+		panic("sys_msync: DEPUTY");
+#endif /* CONFIG_MOSIX_DIAG */
 	down_read(&current->mm->mmap_sem);
 	if (start & ~PAGE_MASK)
 		goto out;
@@ -2634,7 +2653,7 @@
 		error = -EINVAL;
 		break;
 	}
-		
+
 	return error;
 }
 
@@ -3006,7 +3025,7 @@
 	ssize_t		err;
 	unsigned long	limit = current->rlim[RLIMIT_FSIZE].rlim_cur;
 	loff_t		pos = *ppos;
-	
+
 	err = -EINVAL;
 	if (pos < 0)
 		goto out;
@@ -3038,7 +3057,7 @@
 	}
 
 	/*
-	 *	LFS rule 
+	 *	LFS rule
 	 */
 	if ( pos + *count > MAX_NON_LFS && !(file->f_flags&O_LARGEFILE)) {
 		if (pos >= MAX_NON_LFS) {
@@ -3060,7 +3079,7 @@
 	 *
 	 *	Linus frestrict idea will clean these up nicely..
 	 */
-	 
+
 	if (!S_ISBLK(inode->i_mode)) {
 		if (pos >= inode->i_sb->s_maxbytes)
 		{
@@ -3177,6 +3196,9 @@
 		page_fault = __copy_from_user(kaddr+offset, buf, bytes);
 		flush_dcache_page(page);
 		status = mapping->a_ops->commit_write(file, page, offset, offset+bytes);
+#ifdef CONFIG_MOSIX
+		OPENMOSIX_VMODIFIED(inode);
+#endif /* CONFIG_MOSIX */
 		if (page_fault)
 			goto fail_write;
 		if (!status)
@@ -3210,10 +3232,10 @@
 		if ((file->f_flags & O_SYNC) || IS_SYNC(inode))
 			status = generic_osync_inode(inode, OSYNC_METADATA|OSYNC_DATA);
 	}
-	
+
+out_status:
 	err = written ? written : status;
 out:
-
 	return err;
 fail_write:
 	status = -EFAULT;
diff -Naur --exclude=CVS --exclude=configs linux/mm/memory.c linux-openmosix/mm/memory.c
--- linux/mm/memory.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/memory.c	2004-02-05 10:51:31.000000000 +0100
@@ -50,6 +50,10 @@
 #include <asm/uaccess.h>
 #include <asm/tlb.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 unsigned long max_mapnr;
 unsigned long num_physpages;
 unsigned long num_mappedpages;
@@ -543,6 +547,10 @@
 	if (iobuf->nr_pages)
 		return -EINVAL;
 
+#ifdef CONFIG_MOSIX
+	if(stay_me_and_my_clones(DSTAY_FOR_KIOBUF))
+		return(-ENOMEM);
+#endif /* CONFIG_MOSIX */
 	mm = current->mm;
 	dprintk ("map_user_kiobuf: begin\n");
 	
@@ -559,6 +567,21 @@
 	
 	/* Try to fault in all of the necessary pages */
 	down_read(&mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	write_lock_irq(&tasklist_lock);
+	if(iobuf->mm)
+	{
+		printk("map_user_kiobuf: double use\n");
+		write_unlock_irq(&tasklist_lock);
+		up_read(&mm->mmap_sem);
+		unstay_mm(mm);
+		return(-EINVAL);
+	}
+	atomic_inc(&mm->mm_count);
+	atomic_inc(&mm->mm_kiocount);
+	iobuf->mm = mm;
+	write_unlock_irq(&tasklist_lock);
+#endif /* CONFIG_MOSIX */
 	/* rw==READ means read from disk, write into memory area */
 	err = get_user_pages(current, mm, va, pgcount,
 			(rw==READ), 0, iobuf->maplist, NULL);
@@ -566,6 +589,9 @@
 	if (err < 0) {
 		unmap_kiobuf(iobuf);
 		dprintk ("map_user_kiobuf: end %d\n", err);
+#ifdef CONFIG_MOSIX
+		unstay_mm(mm);
+#endif /* CONFIG_MOSIX */
 		return err;
 	}
 	iobuf->nr_pages = err;
@@ -622,6 +648,9 @@
 {
 	int i;
 	struct page *map;
+#ifdef CONFIG_MOSIX
+	struct mm_struct *mm;
+#endif /* CONFIG_MOSIX */
 	
 	for (i = 0; i < iobuf->nr_pages; i++) {
 		map = iobuf->maplist[i];
@@ -637,6 +666,20 @@
 	
 	iobuf->nr_pages = 0;
 	iobuf->locked = 0;
+#ifdef CONFIG_MOSIX
+	write_lock_irq(&tasklist_lock);
+	mm = iobuf->mm;
+	iobuf->mm = NULL;
+	write_unlock_irq(&tasklist_lock);
+	if(!mm)
+	{
+		printk("unmap_kiobuf: no mm!\n");
+		return;
+	}
+	if(atomic_dec_and_test(&mm->mm_kiocount))
+		unstay_mm(mm);
+	mmdrop(mm);
+#endif /* CONFIG_MOSIX */
 }
 
 
@@ -960,6 +1003,10 @@
 		if (reuse) {
 			flush_cache_page(vma, address);
 			establish_pte(vma, address, page_table, pte_mkyoung(pte_mkdirty(pte_mkwrite(pte))));
+#ifdef CONFIG_MOSIX
+                      old_page->young = 0;
+                      old_page->last_young = jiffies;
+#endif /* a.shiloh */
 			spin_unlock(&mm->page_table_lock);
 			return 1;	/* Minor fault */
 		}
@@ -1057,6 +1104,9 @@
 		vmtruncate_list(mapping->i_mmap, pgoff);
 	if (mapping->i_mmap_shared != NULL)
 		vmtruncate_list(mapping->i_mmap_shared, pgoff);
+#ifdef CONFIG_MOSIX
+	OPENMOSIX_VMODIFIED(inode);
+#endif /* CONFIG_MOSIX */
 
 out_unlock:
 	spin_unlock(&mapping->i_shared_lock);
@@ -1122,8 +1172,18 @@
 	swp_entry_t entry = pte_to_swp_entry(orig_pte);
 	pte_t pte;
 	int ret = 1;
+#ifdef CONFIG_MOSIX
+	/* patch conflict resolution
+	   no swap readahead conflict here  */
+	int dpagein = (current->mosix.dflags & DPAGEIN) ^ DPAGEIN;
+#endif /* CONFIG_MOSIX */
 
 	spin_unlock(&mm->page_table_lock);
+#ifdef CONFIG_MOSIX /* comment as before - Qlusters */
+	spin_lock_irq(&runqueue_lock);
+	current->mosix.dflags |= dpagein;
+	spin_unlock_irq(&runqueue_lock);
+#endif /* CONFIG_MOSIX */
 	page = lookup_swap_cache(entry);
 	if (!page) {
 		swapin_readahead(entry);
@@ -1134,6 +1194,12 @@
 			 * we released the page table lock.
 			 */
 			int retval;
+#ifdef CONFIG_MOSIX /* comment as before - Qlusters */
+			spin_lock_irq(&runqueue_lock);
+			current->mosix.dflags &= ~dpagein;
+			spin_unlock_irq(&runqueue_lock);
+#endif /* CONFIG_MOSIX */
+
 			spin_lock(&mm->page_table_lock);
 			retval = pte_same(*page_table, orig_pte) ? -1 : 1;
 			spin_unlock(&mm->page_table_lock);
@@ -1147,6 +1213,11 @@
 	mark_page_accessed(page);
 
 	lock_page(page);
+#ifdef CONFIG_MOSIX
+	spin_lock_irq(&runqueue_lock);
+	current->mosix.dflags &= ~dpagein;
+	spin_unlock_irq(&runqueue_lock);
+#endif /* CONFIG_MOSIX */
 
 	/*
 	 * Back out if somebody else faulted in this pte while we
@@ -1354,6 +1425,14 @@
 		entry = pte_mkdirty(entry);
 	}
 	entry = pte_mkyoung(entry);
+#ifdef CONFIG_MOSIX
+	{
+		struct page *page = pte_page(entry);
+
+		page->young = 0;
+		page->last_young = jiffies;
+	}
+#endif /* CONFIG_MOSIX */
 	establish_pte(vma, address, pte, entry);
 	spin_unlock(&mm->page_table_lock);
 	return 1;
diff -Naur --exclude=CVS --exclude=configs linux/mm/mlock.c linux-openmosix/mm/mlock.c
--- linux/mm/mlock.c	2001-09-18 00:30:23.000000000 +0200
+++ linux-openmosix/mm/mlock.c	2004-02-05 10:51:31.000000000 +0100
@@ -12,6 +12,10 @@
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 static inline int mlock_fixup_all(struct vm_area_struct * vma, int newflags)
 {
 	spin_lock(&vma->vm_mm->page_table_lock);
@@ -218,8 +222,16 @@
 		goto out;
 
 	error = do_mlock(start, len, 1);
+#ifdef CONFIG_MOSIX
+	if (!error)
+		stay_me_and_my_clones(DSTAY_FOR_MLOCK);
+#endif /* CONFIG_MOSIX */
 out:
 	up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	if (error)
+		unstay_mm(current->mm);
+#endif /* CONFIG_MOSIX */
 	return error;
 }
 
@@ -227,11 +239,18 @@
 {
 	int ret;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DDEPUTY)
+		panic("sys_munlock -- DEPUTY");
+#endif /* CONFIG_MOSIX_DIAG */
 	down_write(&current->mm->mmap_sem);
 	len = PAGE_ALIGN(len + (start & ~PAGE_MASK));
 	start &= PAGE_MASK;
 	ret = do_mlock(start, len, 0);
 	up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	unstay_mm(current->mm);
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
 
@@ -285,8 +304,16 @@
 		goto out;
 
 	ret = do_mlockall(flags);
+#ifdef CONFIG_MOSIX
+	if (!ret)
+		stay_me_and_my_clones(DSTAY_FOR_MLOCK);
+#endif /* CONFIG_MOSIX */
 out:
 	up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	if (ret < 0)
+		unstay_mm(current->mm);
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
 
@@ -294,8 +321,15 @@
 {
 	int ret;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DDEPUTY)
+		panic("sys_munlock -- DEPUTY");
+#endif /* CONFIG_MOSIX_DIAG */
 	down_write(&current->mm->mmap_sem);
 	ret = do_mlockall(0);
 	up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	unstay_mm(current->mm);
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
diff -Naur --exclude=CVS --exclude=configs linux/mm/mmap.c linux-openmosix/mm/mmap.c
--- linux/mm/mmap.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/mmap.c	2004-02-05 10:51:31.000000000 +0100
@@ -24,6 +24,16 @@
  */
 #undef DEBUG_MM_RB
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 /* description of effects of mapping type and prot in current implementation.
  * this is due to the limited x86 page protection hardware.  The expected
  * behavior is in parens:
@@ -100,12 +110,31 @@
 
 	if (file) {
 		struct inode *inode = file->f_dentry->d_inode;
+#ifdef CONFIG_MOSIX
+		int was_shared = (inode->i_mapping->i_mmap_shared != NULL);
+#endif /* CONFIG_MOSIX */
 		if (vma->vm_flags & VM_DENYWRITE)
 			atomic_inc(&inode->i_writecount);
 		if(vma->vm_next_share)
 			vma->vm_next_share->vm_pprev_share = vma->vm_pprev_share;
 		*vma->vm_pprev_share = vma->vm_next_share;
+#ifdef CONFIG_MOSIX
+		if(was_shared && !inode->i_mapping->i_mmap_shared)
+			mosix_no_longer_monkey(inode);
+		if(current->mosix.dflags & DREMOTE)
+		{
+			spin_lock_irq(&current->sigmask_lock);
+			current->mosix.asig |= (1 << (REMOTE_FILE_RELEASED-1));
+			spin_unlock_irq(&current->sigmask_lock);
+		}
+		else
+			tell_process(current, DREQ_FILEUNMAP);
+#endif /* CONFIG_MOSIX */
 	}
+#ifdef CONFIG_MOSIX
+	if(current->mosix.stay & DSTAY_PER_MM)
+		unstay_mm(current->mm);
+#endif /* CONFIG_MOSIX */
 }
 
 static inline void remove_shared_vm_struct(struct vm_area_struct *vma)
@@ -163,6 +192,13 @@
 	if (brk <= mm->brk) {
 		if (!do_munmap(mm, newbrk, oldbrk-newbrk))
 			goto set_brk;
+#ifdef CONFIG_MOSIX
+		if(process_told(current, DREQ_FILEUNMAP))
+		{
+			process_ack(current, DREQ_FILEUNMAP);
+			mosix_rebuild_file_list();
+		}
+#endif /* CONFIG_MOSIX */
 		goto out;
 	}
 
@@ -390,18 +426,90 @@
 	return 0;
 }
 
-unsigned long do_mmap_pgoff(struct file * file, unsigned long addr, unsigned long len,
+#ifdef CONFIG_MOSIX
+#define	MMAP_REMOTELY	((current->mosix.dflags&(DDEPUTY|DINCOMING)) == DDEPUTY)
+#endif /* CONFIG_MOSIX */
+
+#ifdef CONFIG_MOSIX_FS
+unsigned long
+mmap_read_instead(struct file *file, unsigned long addr, unsigned long len,
 	unsigned long prot, unsigned long flags, unsigned long pgoff)
 {
+	extern asmlinkage long sys_mprotect(unsigned long,size_t,unsigned long);
+	extern asmlinkage long sys_munmap(unsigned long, size_t);
+	int mm_downed = (current->mosix.dirty_bits & MMAP_MMDOWNED);
+	loff_t loff = pgoff << PAGE_SHIFT;
+	mm_segment_t oldfs;
+	int error;
+
+	if((flags & MAP_TYPE) != MAP_PRIVATE)
+		return(-EPERM);
+	if(!(file->f_mode & 1))
+		return(-EACCES);
+	len = PAGE_ALIGN(len);
+	addr = do_mmap_pgoff(NULL, addr, len, prot | PROT_WRITE,
+				flags & ~MAP_DENYWRITE, pgoff);
+	if(IS_ERR((const void *)addr))
+		return(addr);
+	oldfs = get_fs();
+	set_fs(USER_DS);
+	if(mm_downed)
+		up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX_DFSA
+	error = dfsa_optimized_read(file, loff, addr, len);
+#else
+	error = file->f_op->read(file, (char *)addr, len, &loff);
+#endif /* CONFIG_MOSIX_DFSA */
+	if(error < 0)
+	{
+		set_fs(oldfs);
+		sys_munmap(addr, len);
+		if(mm_downed)
+			down_write(&current->mm->mmap_sem);
+		return(error);
+	}
+	if(error < len)
+		clear_user((void *)addr + error, len - error);
+	set_fs(oldfs);
+	if(!(prot & PROT_WRITE))
+	{
+		prot &= (PROT_READ|PROT_EXEC);
+		if(MMAP_REMOTELY)
+			deputy_mprotect(addr, len, prot);
+		else
+			sys_mprotect(addr, len, prot);
+	}
+	if(mm_downed)
+		down_write(&current->mm->mmap_sem);
+	return(addr);
+}
+#endif /* CONFIG_MOSIX_FS */
+
+unsigned long do_mmap_pgoff(struct file * file, unsigned long addr,
+			unsigned long len, unsigned long prot,
+			unsigned long flags, unsigned long pgoff)
+{
 	struct mm_struct * mm = current->mm;
 	struct vm_area_struct * vma, * prev;
 	unsigned int vm_flags;
 	int correct_wcount = 0;
 	int error;
 	rb_node_t ** rb_link, * rb_parent;
+	unsigned long charged = 0;
+#ifdef CONFIG_MOSIX
+	uint32_t reason_to_come_back = 0;
+	int registration_result = 0;
+#endif /* CONFIG_MOSIX */
 
 	if (file && (!file->f_op || !file->f_op->mmap))
 		return -ENODEV;
+#ifdef CONFIG_MOSIX_FS
+	if(file && file_is_mfs(file))
+		return(mmap_read_instead(file, addr, len, prot, flags, pgoff));
+#endif /* CONFIG_MOSIX_FS */
+#ifdef CONFIG_MOSIX
+ repeat_after_migrating_back:
+#endif /* CONFIG_MOSIX */
 
 	if (!len)
 		return addr;
@@ -416,7 +524,12 @@
 		return -EINVAL;
 
 	/* Too many mappings? */
+
+#ifdef CONFIG_MOSIX
+	if (!(current->mosix.dflags & DDEPUTY) && mm->map_count > max_map_count)
+#else
 	if (mm->map_count > max_map_count)
+#endif /* CONFIG_MOSIX */
 		return -ENOMEM;
 
 	/* Obtain the address to map to. we verify (or select) it and ensure
@@ -430,9 +543,17 @@
 	 * to. we assume access permissions have been handled by the open
 	 * of the memory object, so we don't do any here.
 	 */
+#ifdef CONFIG_MOSIX
+	vm_flags = calc_vm_flags(prot,flags) | (mm ? mm->def_flags : 0) |
+					VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC;
+#else
 	vm_flags = calc_vm_flags(prot,flags) | mm->def_flags | VM_MAYREAD | VM_MAYWRITE | VM_MAYEXEC;
+#endif /* CONFIG_MOSIX */
 
 	/* mlock MCL_FUTURE? */
+#ifdef CONFIG_MOSIX
+	if (mm)
+#endif /* CONFIG_MOSIX */
 	if (vm_flags & VM_LOCKED) {
 		unsigned long locked = mm->locked_vm << PAGE_SHIFT;
 		locked += len;
@@ -457,9 +578,20 @@
 			vm_flags |= VM_SHARED | VM_MAYSHARE;
 			if (!(file->f_mode & FMODE_WRITE))
 				vm_flags &= ~(VM_MAYWRITE | VM_SHARED);
+#ifdef CONFIG_MOSIX
+			if(file->f_mode & FMODE_WRITE)
+				reason_to_come_back |= DSTAY_FOR_MONKEY;
+#endif /* CONFIG_MOSIX */
 
 			/* fall through */
 		case MAP_PRIVATE:
+#ifdef CONFIG_MOSIX
+			if(file->f_dentry->d_inode->i_mapping->i_mmap_shared)
+				reason_to_come_back |= DSTAY_FOR_MONKEY;
+			if(S_ISCHR(file->f_dentry->d_inode->i_mode))
+				reason_to_come_back |= DSTAY_FOR_DEV;
+			if (!(current->mosix.dflags & DINCOMING))
+#endif /* CONFIG_MOSIX */
 			if (!(file->f_mode & FMODE_READ))
 				return -EACCES;
 			break;
@@ -479,6 +611,20 @@
 			break;
 		}
 	}
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dirty_bits & MMAP_MAYSHARE)
+		vm_flags |= VM_MAYSHARE;
+	if(MMAP_REMOTELY)
+	{
+		if(reason_to_come_back)
+		{
+			if(!mosix_go_home(1))
+				return(-EAGAIN);
+			goto again_locally;
+		}
+		goto prepare_vma;
+	}
+#endif /* CONFIG_MOSIX */
 
 	/* Clear old maps */
 munmap_back:
@@ -486,6 +632,12 @@
 	if (vma && vma->vm_start < addr + len) {
 		if (do_munmap(mm, addr, len))
 			return -ENOMEM;
+#ifdef CONFIG_MOSIX
+		if(process_told(current, DREQ_FILEUNMAP)) {
+			process_ack(current, DREQ_FILEUNMAP);
+			mosix_rebuild_file_list();
+		}
+#endif /* CONFIG_MOSIX */
 		goto munmap_back;
 	}
 
@@ -495,6 +647,9 @@
 		return -ENOMEM;
 
 	/* Private writable mapping? Check memory availability.. */
+#ifdef CONFIG_MOSIX
+	if(!(current->mosix.dflags & DINCOMING))
+#endif /* CONFIG_MOSIX */
 	if ((vm_flags & (VM_SHARED | VM_WRITE)) == VM_WRITE &&
 	    !(flags & MAP_NORESERVE)				 &&
 	    !vm_enough_memory(len >> PAGE_SHIFT))
@@ -509,6 +664,9 @@
 	 * specific mapper. the address has already been validated, but
 	 * not unmapped, but the maps are removed from the list.
 	 */
+#ifdef CONFIG_MOSIX
+prepare_vma:
+#endif /* CONFIG_MOSIX */
 	vma = kmem_cache_alloc(vm_area_cachep, SLAB_KERNEL);
 	if (!vma)
 		return -ENOMEM;
@@ -524,6 +682,53 @@
 	vma->vm_private_data = NULL;
 	vma->vm_raend = 0;
 
+#ifdef CONFIG_MOSIX
+	if(file && !(current->mosix.dflags & DREMOTE) && (registration_result =
+		mosix_register_a_file(file, (flags & MAP_DENYWRITE) != 0)) < 0)
+	{
+		error = registration_result;
+		goto free_vma;
+	}
+	/*
+	 * even if we don't end up mapping locally, perform a dummy mapping,
+	 * only to check for fs-specific errors, so we do not fail if and when
+	 * we ever come home:
+	 */
+	if(MMAP_REMOTELY)
+	{
+		vma->vm_file = file;
+		if(file && (error = file->f_op->mmap(file, vma)))
+			goto free_vma;
+		/* did the mapping itself cause us to arrive back home
+		 * (perhaps we were mapping /proc/nnnn/mem)? */
+		if(!MMAP_REMOTELY)
+			goto again_locally_with_vma;
+		addr = mosix_deputy_mmap(file, addr, (flags & MAP_FIXED) != 0,
+			len, vma->vm_flags, pgoff,
+			file ? file->f_dentry->d_inode->i_size : 0,
+			file ? vma->vm_ops->nopage : NULL);
+		if(IS_ERR((const void *)addr))
+		{
+			error = addr;
+			if(error == -EDOITATHOME)
+			/* remote resource shortage: don't despair, come back */
+			if(mosix_go_home(1))
+				goto again_locally_with_vma;
+			goto free_vma;
+		}
+		/* we did not really want that vma... only to check */
+		kmem_cache_free(vm_area_cachep, vma);
+		/* meanwhile someone else could map the same file shared, so: */
+		if(file && file->f_dentry->d_inode->i_mapping->i_mmap_shared)
+		{
+			if(!mosix_go_home(0))
+				return(-EAGAIN);
+			stay_me_and_my_clones(DSTAY_FOR_MONKEY);
+		}
+		return(addr);
+	}
+
+#endif /* CONFIG_MOSIX */
 	if (file) {
 		error = -EINVAL;
 		if (vm_flags & (VM_GROWSDOWN|VM_GROWSUP))
@@ -585,6 +790,12 @@
 		mm->locked_vm += len >> PAGE_SHIFT;
 		make_pages_present(addr, addr + len);
 	}
+#ifdef CONFIG_MOSIX
+	if(reason_to_come_back)
+		stay_me_and_my_clones(reason_to_come_back);
+	if(file && (vm_flags & VM_SHARED))
+		mosix_bring_monkey_users_back(file->f_dentry->d_inode);
+#endif /* CONFIG_MOSIX */
 	return addr;
 
 unmap_and_free_vma:
@@ -597,7 +808,22 @@
 	zap_page_range(mm, vma->vm_start, vma->vm_end - vma->vm_start);
 free_vma:
 	kmem_cache_free(vm_area_cachep, vma);
+#ifdef CONFIG_MOSIX
+	if(registration_result > 0)
+		mosix_undo_last_file_registration(file, registration_result);
+#endif /* CONFIG_MOSIX */
 	return error;
+#ifdef CONFIG_MOSIX
+again_locally_with_vma:
+	kmem_cache_free(vm_area_cachep, vma);
+	if(registration_result > 0)
+		mosix_undo_last_file_registration(file, registration_result);
+	registration_result = 0;
+again_locally:
+	mm = current->mm;
+	reason_to_come_back = 0;
+	goto repeat_after_migrating_back;
+#endif /* CONFIG_MOSIX */
 }
 
 /* Get an address range which is currently unmapped.
@@ -643,6 +869,10 @@
 
 unsigned long get_unmapped_area(struct file *file, unsigned long addr, unsigned long len, unsigned long pgoff, unsigned long flags)
 {
+#ifdef CONFIG_MOSIX
+	if(MMAP_REMOTELY && !(flags & MAP_FIXED))
+		return(PAGE_ALIGN(addr));
+#endif /* CONFIG_MOSIX */
 	if (flags & MAP_FIXED) {
 		if (addr > TASK_SIZE - len)
 			return -ENOMEM;
@@ -1019,9 +1249,20 @@
 	int ret;
 	struct mm_struct *mm = current->mm;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		return(deputy_munmap(addr, len));
+#endif /* CONFIG_MOSIX */
 	down_write(&mm->mmap_sem);
 	ret = do_munmap(mm, addr, len);
 	up_write(&mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	if(process_told(current, DREQ_FILEUNMAP))
+	{
+		process_ack(current, DREQ_FILEUNMAP);
+		mosix_rebuild_file_list();
+	}
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
 
@@ -1044,6 +1285,10 @@
 	if ((addr + len) > TASK_SIZE || (addr + len) < addr)
 		return -EINVAL;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		return(mosix_deputy_brk(addr, len));
+#endif /* CONFIG_MOSIX */
 	/*
 	 * mlock MCL_FUTURE?
 	 */
diff -Naur --exclude=CVS --exclude=configs linux/mm/mprotect.c linux-openmosix/mm/mprotect.c
--- linux/mm/mprotect.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/mprotect.c	2004-02-05 10:51:31.000000000 +0100
@@ -270,6 +270,10 @@
 	struct vm_area_struct * vma, * next, * prev;
 	int error = -EINVAL;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DDEPUTY)
+		panic("sys_mprotect: DEPUTY");
+#endif /* CONFIG_MOSIX_DIAG */
 	if (start & ~PAGE_MASK)
 		return -EINVAL;
 	len = PAGE_ALIGN(len);
diff -Naur --exclude=CVS --exclude=configs linux/mm/mremap.c linux-openmosix/mm/mremap.c
--- linux/mm/mremap.c	2004-01-05 14:53:56.000000000 +0100
+++ linux-openmosix/mm/mremap.c	2004-06-11 13:01:55.000000000 +0200
@@ -14,6 +14,9 @@
 #include <asm/pgalloc.h>
 
 extern int vm_enough_memory(long pages);
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
 
 static inline pte_t *get_one_pte(struct mm_struct *mm, unsigned long addr)
 {
@@ -77,12 +80,16 @@
 static int move_one_page(struct mm_struct *mm, unsigned long old_addr, unsigned long new_addr)
 {
 	int error = 0;
-	pte_t * src;
+	pte_t * src, * dst;
 
 	spin_lock(&mm->page_table_lock);
 	src = get_one_pte(mm, old_addr);
-	if (src)
-		error = copy_one_pte(mm, src, alloc_one_pte(mm, new_addr));
+	if (src) {
+		dst = alloc_one_pte(mm, new_addr);
+		src = get_one_pte(mm, old_addr);
+		if (src) 
+			error = copy_one_pte(mm, src, dst);
+	}
 	spin_unlock(&mm->page_table_lock);
 	return error;
 }
@@ -223,6 +230,10 @@
 	struct vm_area_struct *vma;
 	unsigned long ret = -EINVAL;
 
+#ifdef CONFIG_MOSIX_DIAG
+	if(current->mosix.dflags & DDEPUTY)
+		panic("sys_mremap: DEPUTY");
+#endif /* CONFIG_MOSIX_DIAG */
 	if (flags & ~(MREMAP_FIXED | MREMAP_MAYMOVE))
 		goto out;
 
@@ -258,16 +269,20 @@
 		if ((addr <= new_addr) && (addr+old_len) > new_addr)
 			goto out;
 
-		do_munmap(current->mm, new_addr, new_len);
+		ret = do_munmap(current->mm, new_addr, new_len);
+		if (ret && new_len)
+			goto out;
 	}
 
 	/*
 	 * Always allow a shrinking remap: that just unmaps
 	 * the unnecessary pages..
 	 */
-	ret = addr;
 	if (old_len >= new_len) {
-		do_munmap(current->mm, addr+new_len, old_len - new_len);
+		ret = do_munmap(current->mm, addr+new_len, old_len - new_len);
+		if (ret && old_len != new_len)
+			goto out;
+		ret = addr;
 		if (!(flags & MREMAP_FIXED) || (new_addr == addr))
 			goto out;
 	}
@@ -360,5 +375,12 @@
 	down_write(&current->mm->mmap_sem);
 	ret = do_mremap(addr, old_len, new_len, flags, new_addr);
 	up_write(&current->mm->mmap_sem);
+#ifdef CONFIG_MOSIX
+	if(process_told(current, DREQ_FILEUNMAP))
+	{
+		process_ack(current, DREQ_FILEUNMAP);
+		mosix_rebuild_file_list();
+	}
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
